// Datototeka zad3.cpp
#include "aes.h"
#include "aes_proc.h"
#include "aes_dist.h"
#include <iostream>

// Ukljucujemo prostore imena esa i std
using namespace aes;
using namespace std;

// Redovi cekanja
red red1,red2;
// Salteri
resurs uni_salt(2),pak_salt(1);
// Objekat simulacije
simulacija simu;
// Raspodele
raspodela rni(76531), rn1(11615), rn2(36517), rn3(61521), rn4(98737);

// Srednje vreme dolaska entiteta u univerzalni salter
const double SRVRDOLUNI   = 60;
// Srednja vremena opsluge entiteta u univerzalnom salteru u zavisnosti od usluge 
const double SRVROPSUNI[] = {40, 50, 15, 70};
// Srednje vreme dolaska entiteta u paketski salter
const double SRVRDOLPAK   = 200;
// Modifikator vremena dolaska entiteta u paketski salter
const double MODDOLPAK    = 80;
// Srednje vreme opsluge entiteta u paketskom salteru
const double SRVROPSPAK   = 100;
// Standardna devijacija vremena opsluge entiteta u paketskom salteru
const double STDEVOPSPAK  = 40;
// Minimalno vreme opsluge entiteta u paketskom salteru
const double MINOPSPAK    = 20;

// Klasa korisnika
class korisnik:public agent {
  // Brojac korisnika
  static size_t _idc;    
  // Redni broj korisnika
  size_t _id;    
public:
  // Konstruktor
  korisnik():agent() { _id = ++_idc; }
public:
  // Vraca id korisnika
  size_t vrati_id() { return _id; } 
}; 
size_t korisnik::_idc = 0;

// Klasa dogadjaja dolazak korisnika na univerzalne saltere
class dolazak_uni_korisnika:public dogadjaj {
public:
  // Konstruktor
  dolazak_uni_korisnika():dogadjaj(1) {}
  // Akcija
  void akcija();
  // Pomocna funkcija za pravljenje dogadjaja 
  static dolazak_uni_korisnika* napravi(korisnik* kor,vreme vn) {
    dolazak_uni_korisnika* dk = new dolazak_uni_korisnika;
    dk->postavi_agenta(0,kor);
    dk->postavi_vreme(simu.vrati_vreme()+vn);
    return dk;
  }
};
// Klasa dogadjaja odlazak korisnika sa univerzalnih saltera
class odlazak_uni_korisnika:public dogadjaj {
public:
  // Konstruktor
  odlazak_uni_korisnika():dogadjaj(1) {}
  // Akcija dogadjaja
  void akcija();
  // Pomocna funkcija za pravljenje dogadjaja
  static odlazak_uni_korisnika* napravi(korisnik* kor,vreme vn) {
    odlazak_uni_korisnika* ok = new odlazak_uni_korisnika;
    ok->postavi_agenta(0,kor);
    ok->postavi_vreme(simu.vrati_vreme()+vn);
    return ok;
  }
};

// Klasa dogadjaja dolazak korisnika na paketski salter
class dolazak_pak_korisnika:public dogadjaj {
public:
  // Konstruktor
  dolazak_pak_korisnika():dogadjaj(1) {}
  // Akcija
  void akcija();
  // Pomocna funkcija za pravljenje dogadjaja 
  static dolazak_pak_korisnika* napravi(korisnik* kor,vreme vn) {
    dolazak_pak_korisnika* dk = new dolazak_pak_korisnika;
    dk->postavi_agenta(0,kor);
    dk->postavi_vreme(simu.vrati_vreme()+vn);
    return dk;
  }
};
// Klasa dogadjaja odlazak korisnika sa paketskog saltera
class odlazak_pak_korisnika:public dogadjaj {
public:
  // Konstruktor
  odlazak_pak_korisnika():dogadjaj(1) {}
  // Akcija dogadjaja
  void akcija();
  // Pomocna funkcija za pravljenje dogadjaja
  static odlazak_pak_korisnika* napravi(korisnik* kor,vreme vn) {
    odlazak_pak_korisnika* ok = new odlazak_pak_korisnika;
    ok->postavi_agenta(0,kor);
    ok->postavi_vreme(simu.vrati_vreme()+vn);
    return ok;
  }
};

// Klasa dogadjaja zavrsetka simulacije
class kraj: public dogadjaj {
public:
  // Konstruktor dogadjaja kraj
  kraj():dogadjaj(0) {}
public:
  // Akcija dogadjaja
  void akcija() { simu.zaustavi(); }
  // Pomocna funkcija za pravljenje dogadjaja
  static kraj* napravi(vreme vn) {
    kraj* k = new kraj;
    k->postavi_vreme(simu.vrati_vreme()+vn);
    return k;
  }
};

// Akcija
void dolazak_uni_korisnika::akcija() { 
  korisnik *kor,*prvi_kor,*novi_kor;
  double vi, vreme_opsluge = 0.0;
  // Korisnik koji dolazi u postu
  kor = dynamic_cast<korisnik*>(vrati_agenta(0));
  #ifdef STAMPA
  cout << "ured_uni" << "," << kor->vrati_id() << "," << simu.vrati_vreme() << endl;
  #endif
  // Postavi korisnika u red cekanja
  red1.smesti(kor);
  // Ukoliko su univerzalni salteri raspolozivi
  if(uni_salt.raspoloziv()) {
    // Izvadi prvog klijenta iz reda
    prvi_kor = dynamic_cast<korisnik*>(red1.prednji());
    // Prvi korisnik izlazi iz reda
    red1.vadi();
    #ifdef STAMPA
    cout << "izred_uni" << "," << kor->vrati_id() << "," << simu.vrati_vreme() << endl;
    #endif
    // Zauzmi jedno mesto u salteru
    uni_salt.zauzmi();
    #ifdef STAMPA
    cout << "usal_uni" << "," << kor->vrati_id() << "," << simu.vrati_vreme() << endl;
    #endif
    // Verovatnoca izbora usluge
    vi = rni();
    // Vreme opsluge na osnovu izabrane vrste usluge
    if(vi<0.20) 
      vreme_opsluge = rn2.expo(SRVROPSUNI[0]);
    else if(vi<0.60) 
      vreme_opsluge = rn2.expo(SRVROPSUNI[1]);
    else if(vi<0.75) 
      vreme_opsluge = rn2.expo(SRVROPSUNI[2]);
    else if(vi<1.00)
      vreme_opsluge = rn2.expo(SRVROPSUNI[3]);
    // Rasporedi klijenta za kraj opsluge 
    simu.rasporedi(odlazak_uni_korisnika::napravi(prvi_kor,vreme_opsluge));
  }
  // Stvaramo narednog korisnika
  novi_kor = new korisnik;    
  // Postavljamo vreme narednog dolaska
  simu.rasporedi(dolazak_uni_korisnika::napravi(novi_kor,rn1.expo(SRVRDOLUNI)));
}

// Akcija dogadjaja
void odlazak_uni_korisnika::akcija() {
  korisnik *kor, *prvi_kor;
  double vi, vreme_opsluge = 0.0;
  // Korisnik koji odlazi
  kor = dynamic_cast<korisnik*>(vrati_agenta(0));
  // Vrati salter
  uni_salt.oslobodi();
  #ifdef STAMPA
  cout << "izsal_uni" << "," << kor->vrati_id() << "," << simu.vrati_vreme() << endl;  
  #endif
  // Korisnik odlazi iz poste - unistavamo tekuceg korisnik
  delete kor;
  // Ukoliko red nije prazan
  if(red1.vrati_velicinu()>0) {
    // Izvadi prvog korisnika iz reda
    prvi_kor = dynamic_cast<korisnik*>(red1.prednji());
    red1.vadi();
    #ifdef STAMPA
    cout << "izred_uni" << "," << prvi_kor->vrati_id() << "," << simu.vrati_vreme() << endl;  
    #endif
    // Zauzmi jedno mesto u salteru
    uni_salt.zauzmi();
    #ifdef STAMPA
    cout << "usal_uni" << "," << prvi_kor->vrati_id() << "," << simu.vrati_vreme() << endl;  
    #endif
    // Verovatnoca izbora usluge
    vi = rni();
    // Vreme opsluge na osnovu izabrane vrste usluge
    if(vi<0.20) 
      vreme_opsluge = rn2.expo(SRVROPSUNI[0]);
    else if(vi<0.60) 
      vreme_opsluge = rn2.expo(SRVROPSUNI[1]);
    else if(vi<0.75) 
      vreme_opsluge = rn2.expo(SRVROPSUNI[2]);
    else if(vi<1.00)
      vreme_opsluge = rn2.expo(SRVROPSUNI[3]);
    // Rasporedi klijenta za kraj opsluge 
    simu.rasporedi(odlazak_uni_korisnika::napravi(prvi_kor,vreme_opsluge));
  }
}

// Akcija
void dolazak_pak_korisnika::akcija() {
  korisnik *kor,*prvi_kor,*novi_kor;
  double vreme_opsluge;
  // Korisnik koji dolazi u postu
  kor = dynamic_cast<korisnik*>(vrati_agenta(0));
  #ifdef STAMPA
  cout << "ured_pak" << "," << kor->vrati_id() << "," << simu.vrati_vreme() << endl;
  #endif
  // Postavi korisnika u red cekanja
  red2.smesti(kor);
  // Ukoliko je salter raspoloziv
  if(pak_salt.raspoloziv()) {
    // Izvadi prvog korisnika iz reda
    prvi_kor = dynamic_cast<korisnik*>(red2.prednji());
    // Prvi korisnik izlazi iz reda
    red2.vadi();
    #ifdef STAMPA
    cout << "izred_pak" << "," << kor->vrati_id() << "," << simu.vrati_vreme() << endl;
    #endif
    // Zauzmi jedno mesto u salteru
    pak_salt.zauzmi();
    #ifdef STAMPA
    cout << "usal_pak" << "," << kor->vrati_id() << "," << simu.vrati_vreme() << endl;
    #endif
    do {
      vreme_opsluge = rn4.norm(SRVROPSPAK,STDEVOPSPAK);
    } while(vreme_opsluge<MINOPSPAK);
    // Rasporedi klijenta za kraj opsluge 
    simu.rasporedi(odlazak_pak_korisnika::napravi(prvi_kor,vreme_opsluge));
  }
  // Stvaramo narednog korisnika
  novi_kor = new korisnik;    
  // Postavljamo vreme narednog dolaska
  simu.rasporedi(dolazak_pak_korisnika::napravi(novi_kor,rn3.unif(SRVRDOLPAK-MODDOLPAK,SRVRDOLPAK+MODDOLPAK)));
}

// Akcija 
void odlazak_pak_korisnika::akcija() {
  korisnik *kor, *prvi_kor;
  double vreme_opsluge;
  // Korisnik koji odlazi
  kor = dynamic_cast<korisnik*>(vrati_agenta(0));
  // Vrati salter
  pak_salt.oslobodi();
  #ifdef STAMPA
  cout << "izsal_pak" << "," << kor->vrati_id() << "," << simu.vrati_vreme() << endl;  
  #endif
  // Klijent odlazi iz poste - unistavamo tekuceg klijenta
  delete kor;
  // Ukoliko red nije prazan
  if(red2.vrati_velicinu()>0) {
    // Izvadi prvog korisnika iz reda
    prvi_kor = dynamic_cast<korisnik*>(red2.prednji());
    red2.vadi();
    #ifdef STAMPA
    cout << "izred_pak" << "," << prvi_kor->vrati_id() << "," << simu.vrati_vreme() << endl;  
    #endif
    // Zauzmi jedno mesto u salteru
    pak_salt.zauzmi();
    #ifdef STAMPA
    cout << "usal_pak" << "," << prvi_kor->vrati_id() << "," << simu.vrati_vreme() << endl;  
    #endif
    do {
      vreme_opsluge = rn4.norm(SRVROPSPAK,STDEVOPSPAK);
    } while(vreme_opsluge<MINOPSPAK);
    // Rasporedi klijenta za kraj opsluge 
    simu.rasporedi(odlazak_pak_korisnika::napravi(prvi_kor,vreme_opsluge));
  }
}

int main() {
  // Stvaramo prvog korisnika
  korisnik *kor1 = new korisnik, *kor2 = new korisnik;
  // Postavljamo prvi dogadja u listu sto je odgovara dolasku prvog klijenta
  simu.rasporedi(dolazak_uni_korisnika::napravi(kor1,rn1.expo(SRVRDOLUNI)));
  // Postavljamo prvi dogadja u listu sto je odgovara dolasku prvog klijenta
  simu.rasporedi(dolazak_pak_korisnika::napravi(kor2,rn3.unif(SRVRDOLPAK-MODDOLPAK,SRVRDOLPAK+MODDOLPAK)));
  // Rasporedi dogadjaj zavrsetka simulacije
  simu.rasporedi(kraj::napravi(43200));
  // Izvrsavamo simulaciju
  simu.izvrsi();
  #ifdef STAMPA
  // Stampamo vreme simulacije
  cout << "vsim" << "," << -1 << "," << simu.vrati_vreme() << endl; 
  #endif
  return 0;
}
